package space.kklochko.simple_jbdd.tests.commands;

import space.kklochko.simple_jbdd.tests.Test;
import java.util.Map;
import java.util.TreeMap;

public abstract class AbstractTestCommand<T extends Test> {
    protected String type;
    protected String label;

    public AbstractTestCommand(String label) {
        setLabel(label);
    }

    public abstract boolean test();

    public Map<String, String> getLabels() {
        Map<String, String> labels = new TreeMap<String, String>();
        labels.put(getType(), this.getLabel());
        return labels;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getLabel() {
        return label;
    }

    public abstract void setObject(T object);

    public abstract T getObject();
}

