package space.kklochko.simple_jbdd.tests.commands.decorators;

import space.kklochko.simple_jbdd.tests.Test;
import space.kklochko.simple_jbdd.tests.commands.AbstractTestCommand;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class BlockDecorator<T extends Test> extends AbstractDecorator<T> {
    public BlockDecorator(String label, AbstractTestCommand<T> command, Method method, String type) {
        super(label, command);
        setType(type);
        setMethod(method);
    }

    public boolean test() {
        boolean result = runMethod();

        if(!result)
            return false;

        return getCommand().test();
    }

    public boolean runMethod() {
        try {
            method.setAccessible(true);
            method.invoke(getCommand().getObject());
            return true;
        } catch (InvocationTargetException e) {
            Throwable exception = e.getCause();

            if(exception instanceof AssertionError)
                throw (AssertionError) exception;

            System.err.println(e.getMessage());
            throw new RuntimeException(e);
        } catch (IllegalAccessException e) {
            System.err.println("Check access modifiers.");
            throw new RuntimeException(e);
        }
    };
}

