package space.kklochko.simple_jbdd.tests.factories;

import space.kklochko.simple_jbdd.tests.Test;
import space.kklochko.simple_jbdd.tests.commands.AbstractTestCommand;

import java.util.*;

public class TestCommandQueueFactory {
    private ArrayList<Test> tests;
    private TestCommandFactory factory;

    public TestCommandQueueFactory(ArrayList<Test> tests) {
        setTests(tests);
        setFactory(new TestCommandFactory());
    }

    public TestCommandQueueFactory(ArrayList<Test> tests, TestCommandFactory factory) {
        setTests(tests);
        setFactory(factory);
    }

    public ArrayList<AbstractTestCommand<Test>> create() {
        ArrayList<AbstractTestCommand<Test>> commands = new ArrayList<AbstractTestCommand<Test>>();

        for(Test test : getTests()) {
            AbstractTestCommand<Test> command = getFactory().create(test);
            commands.add(command);
        }

        return commands;
    }

    public ArrayList<Test> getTests() {
        return tests;
    }

    public void setTests(ArrayList<Test> tests) {
        this.tests = tests;
    }

    public TestCommandFactory getFactory() {
        return factory;
    }

    public void setFactory(TestCommandFactory factory) {
        this.factory = factory;
    }
}

