package space.kklochko.simple_jbdd.tests.reports.fmt;

import space.kklochko.simple_jbdd.tests.Test;

import java.util.AbstractMap;
import java.util.ArrayList;

public class SimpleTestReportFormatter extends AbstractTestReportFormatter {
    final private String passedIcon = "✓";
    final private String failedIcon = "⨯";

    public SimpleTestReportFormatter() {
        super(null, false);
    }

    public SimpleTestReportFormatter(ArrayList<AbstractMap.SimpleEntry<String, String>> testMetaData, boolean isPassed) {
        super(testMetaData, isPassed);
    }

    public String format() {
        String status = (isPassed()) ? getPassedIcon() : getFailedIcon();
        String title = getTestMetaData().get(0).getValue();

        String result = String.format("%s %s\n", status, title);

        for(int i=1; i<getTestMetaData().size(); ++i) {
            AbstractMap.SimpleEntry<String, String> pair = getTestMetaData().get(i);
            result += String.format("\t%s: %s\n", pair.getKey(), pair.getValue());
        }

        return result + '\n';
    }

    public String getPassedIcon() {
        return passedIcon;
    }

    public String getFailedIcon() {
        return failedIcon;
    }
}

